use std::path::Path;
use rusqlite::{params, Connection, Result};
use crate::def;
use crate::def::Task;

pub(crate) fn startup(path: &Path) -> Result<(Connection)> {
    // let conn = Connection::open_in_memory()?;
    let conn = Connection::open(path)?;
    
    conn.execute(
        "CREATE TABLE IF NOT EXISTS tasks (
                id INTEGER PRIMARY KEY,
                checked INTEGER NOT NULL,
                value TEXT NOT NULL
        )",
        ()
    )?;
    
    // todo
    
    Ok(conn)
}

pub(crate) fn get_tasks(conn: &Connection) -> Result<()> {
    let mut stmt = conn.prepare("SELECT checked, value FROM tasks")?;
    let task_iter = stmt.query_map([], |row| {
        Ok(Task {
            checked: row.get(0)?,
            value: row.get(1)?,
        })
    })?;
    
    for task in task_iter {
        println!("{:?}", task);
    }
    
    Ok(())
}

pub(crate) fn insert_task(task: Task, conn: &Connection) -> Result<()> {
    conn.execute(
        "INSERT INTO tasks (checked, value) VALUES (?1, ?2)",
        (&task.checked, &task.value),
    )?;
    
    Ok(())
}